<?php
/*
Plugin Name: Moo Collapsing Archives
Plugin URI: http://www.3dolab.net/en/259/moo-collapsing-categories-and-archives
Description: Allows users to expand and collapse archive links with MooTools.P 2.7 OR LESS  <a href='options-general.php?page=collapsArch.php'>Options and Settings</a> 
Author: 3dolab
Version: 0.5.2
Author URI: http://www.3dolab.net

Copyright 2010 3dolab

This work is largely based on the Collapsing Archives plugin by Robert Felty
(http://robfelty.com), which was also distributed under the GPLv2.
His website has lots of informations.

This file is part of Moo Collapsing Archives

    Moo Collapsing Archives is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Moo Collapsing Archives is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Collapsing Archives; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
$url = get_settings('siteurl');
global $collapsArchVersion;
$collapsArchVersion = '0.5.2';

// LOCALIZATION
function collapsArch_load_domain() {
	load_plugin_textdomain( 'collapsArch', WP_PLUGIN_DIR."/".basename(dirname(__FILE__)), basename(dirname(__FILE__)) );
}
add_action('init', 'collapsArch_load_domain'); 


/****************/
if (!is_admin()) {
  wp_register_script('moocore', "$url/wp-content/plugins/mootools-collapsing-archives/mootools-1.2-core-yc.js", false, '1.2');
  wp_register_script('moomore', "$url/wp-content/plugins/mootools-collapsing-archives/mootools-1.2-more.js", false, '1.2');
  wp_enqueue_script('moocore');
  wp_enqueue_script('moomore');
  wp_enqueue_script('collapsFunctions',
  WP_PLUGIN_URL . "/mootools-collapsing-archives/collapsFunctions.js",
      array('moocore','moomore'), '1.2', false);
  add_action( 'wp_head', array('collapsArch','get_head'));
} else {
  // call upgrade function if current version is lower than actual version
  $dbversion = get_option('collapsArchVersion');
  if (!$dbversion || $collapsArchVersion != $dbversion)
    collapsArch::init();
}
add_action('admin_menu', array('collapsArch','setup'));
register_activation_hook(__FILE__, array('collapsArch','init'));

class collapsArch {

	function init() {
    global $collapsArchVersion;
    include('collapsArchStyles.php');
    $dbversion = get_option('collapsArchVersion');
    if ($collapsArchVersion != $dbversion && $selected!='custom') {
      $style = $defaultStyles[$selected];
      update_option( 'collapsArchStyle', $style);
      update_option( 'collapsArchVersion', $collapsArchVersion);
    }
    $defaultStyles=compact('selected','default','block','noArrows','custom');
    if( function_exists('add_option') ) {
      update_option( 'collapsArchOrigStyle', $style);
      update_option( 'collapsArchDefaultStyles', $defaultStyles);
    }
    if (!get_option('collapsArchStyle')) {
			add_option( 'collapsArchStyle', $style);
		}
    if (!get_option('collapsArchSidebarId')) {
      add_option( 'collapsArchSidebarId', 'sidebar');
    }
    if (!get_option('collapsArchVersion')) {
      add_option( 'collapsArchVersion', $collapsArchVersion);
		}

	}

	function setup() {
		if( function_exists('add_options_page') && current_user_can('manage_options') ) {
			add_options_page(__('Collapsing Archives', 'collapsArch'),__('Collapsing Archives', 'collapsArch'),1,basename(__FILE__),array('collapsArch','ui'));
		}
	}

	function ui() {
		include_once( 'collapsArchUI.php' );
	}



	function get_head() {
    $style=stripslashes(get_option('collapsArchStyle'));
    echo "<style type='text/css'>
    $style
    </style>\n";
	}
function phpArrayToJS($array, $name, $options) {
    /* generates javscript code to create an array from a php array */
    print "try { $name" . 
        "['catTest'] = 'test'; } catch (err) { $name = new Object(); }\n";
    if (!$options['expandYears'] && $options['expandMonths']) {
      $lastYear = -1;
      foreach ($array as $key => $value){
        $parts = explode('-', $key);
        $label = $parts[0];
        $year = $parts[1];
        $moreparts = explode(':', $key);
        $widget = $moreparts[1];
        if ($year != $lastYear) {
          if ($lastYear>0)
            print  "';\n";
          print $name . "['$label-$year:$widget'] = '" . 
              addslashes(str_replace("\n", '', $value));

          $lastYear=$year;
        } else {
          print addslashes(str_replace("\n", '', $value));
        }
      }
      print  "';\n";
    } else {
      foreach ($array as $key => $value){
        print $name . "['$key'] = '" . 
            addslashes(str_replace("\n", '', $value)) . "';\n";
      }
    }
  }
}
include_once( 'collapsArchList.php' );

function collapsArch($args='') {
  global $collapsArchItems, $wpdb, $month;
  include('defaults.php');
  $options=wp_parse_args($args, $defaults);
  if (!is_admin()) {
    if (!$options['number'] || $options['number']=='') 
      $options['number']=1;
    $archives = list_archives($options);
    $archives .= "<li style='display:none'><script type=\"text/javascript\">\n";
    $archives .= "// <![CDATA[\n";
      $archives .= '/* These variables are part of the Moo Collapsing Archives Plugin
   * version: 0.5
   * Copyright 2010 3DO lab (3dolab.net)
           */' ."\n";
extract($options);
$post_attrs = "post_date != '0000-00-00 00:00:00' AND post_status = 'publish'";
if ($expand==1) {
    $expandSym='+';
    $collapseSym='—';
  } elseif ($expand==2) {
    $expandSym='[+]';
    $collapseSym='[—]';
  } elseif ($expand==3) {
    $expandSym="<img src='". $url .
         "/wp-content/plugins/mootools-collapsing-archives/" . 
         "img/expand.gif' alt='expand' />";
    $collapseSym="<img src='". $url .
         "/wp-content/plugins/mootools-collapsing-archives/" . 
         "img/collapse.gif' alt='collapse' />";
  } elseif ($expand==4) {
    $expandSym=htmlentities($customExpand);
    $collapseSym=htmlentities($customCollapse);
  } else {
    $expandSym='&#9658;';
    $collapseSym='&#9660;';
  }
  if ($expand==3) {
    $expandSymJS='expandImg';
    $collapseSymJS='collapseImg';
  } else {
    $expandSymJS=$expandSym;
    $collapseSymJS=$collapseSym;
  }
  if( $expandCurrentYear ){
	$expandCookieYear = "if (!Cookie.read('collapsArch-".date('Y').":".$number."')){Cookie.write('collapsArch-".date('Y').":".$number."', 'inline');}";
	$archives .= $expandCookieYear;
      }
  if( $expandCurrentMonth ){
	    $expandCookieMonth = "if (!Cookie.read('collapsArch-".date('Y')."-".date('n').":".$number."')){Cookie.write('collapsArch-".date('Y')."-".date('n').":".$number."', 'inline');}";
	    $archives .= $expandCookieMonth;
      }
    $expandText= __('click to expand', 'collapsArch');
    $collapseText= __('click to collapse', 'collapsArch');
    $archives .= "var expand=\"$expandSymJS\";";
    $archives .= "var collapse=\"$collapseSymJS\";";
    $archives .= "var animate=\"$animate\";";
    $archives .= "var expandSym=\"$expandSym\";\n";
    $archives .= "var collapseSym=\"$collapseSym\";\n";
    $archives .= "var expandText=\"$expandText\";\n";
    $archives .= "var collapseText=\"$collapseText\";\n";
    print $archives;
    // now we create an array indexed by the id of the ul for posts
    collapsArch::phpArrayToJS($collapsArchItems, 'collapsItems', $options);
    print "// ]]>\n</script></li>\n";
  }
}
$version = get_bloginfo('version');
if (preg_match('/^(2\.[8-9]|3\..*)/', $version))
  include('collapsArchWidget.php');
?>